/*
                           ....::::: In The Name Of GOD :::::....

    TFT LCD (ILI9325-ILI9320 LCD Driver) Functions For LPC17xx
    By Ali Imanifar   Shahrood University of Technology    1389/06/16   

*/

#define LCD_CS_PIN  8	//you should choose between 8 or 9 or 10 or 14 or 15
#define LCD_RS_PIN  9	//you should choose between 8 or 9 or 10 or 14 or 15
#define LCD_WR_PIN  10	//you should choose between 8 or 9 or 10 or 14 or 15
#define LCD_RD_PIN  14	//you should choose between 8 or 9 or 10 or 14 or 15
#define LCD_RST_PIN 15	//you should choose between 8 or 9 or 10 or 14 or 15 

#define PORTRAIT
//#define LANDSCAPE

#define RST_LOW       LPC_GPIO1->FIOCLR1=(1<<(LCD_RST_PIN-8))
#define RST_HIGH      LPC_GPIO1->FIOSET1=(1<<(LCD_RST_PIN-8))
#define RS_LOW        LPC_GPIO1->FIOCLR1=(1<<(LCD_RS_PIN-8))
#define RS_HIGH       LPC_GPIO1->FIOSET1=(1<<(LCD_RS_PIN-8))
#define CS_LOW        LPC_GPIO1->FIOCLR1=(1<<(LCD_CS_PIN-8))
#define CS_HIGH       LPC_GPIO1->FIOSET1=(1<<(LCD_CS_PIN-8))
#define RD_LOW        LPC_GPIO1->FIOCLR1=(1<<(LCD_RD_PIN-8))
#define RD_HIGH       LPC_GPIO1->FIOSET1=(1<<(LCD_RD_PIN-8))
#define WR_LOW        LPC_GPIO1->FIOCLR1=(1<<(LCD_WR_PIN-8))
#define WR_HIGH       LPC_GPIO1->FIOSET1=(1<<(LCD_WR_PIN-8))

#define LCD_DATAPORT_INPUT  LPC_GPIO1->FIODIRH=0x0000
#define LCD_DATAPORT_OUTPUT LPC_GPIO1->FIODIRH=0xffff
#define LCD_DATAPORT_CLEAR  LPC_GPIO1->FIOCLRH=0xffff

#define TS_INS_START_OSC             0x00
#define TS_INS_DRIV_OUT_CTRL         0x01
#define TS_INS_DRIV_WAV_CTRL         0x02
#define TS_INS_ENTRY_MOD             0x03
#define TS_INS_RESIZE_CTRL           0x04
#define TS_INS_DISP_CTRL1            0x07
#define TS_INS_DISP_CTRL2            0x08
#define TS_INS_DISP_CTRL3            0x09
#define TS_INS_DISP_CTRL4            0x0A
#define TS_INS_RGB_DISP_IF_CTRL1     0x0C
#define TS_INS_FRM_MARKER_POS        0x0D
#define TS_INS_RGB_DISP_IF_CTRL2     0x0F
#define TS_INS_POW_CTRL1             0x10
#define TS_INS_POW_CTRL2             0x11
#define TS_INS_POW_CTRL3             0x12
#define TS_INS_POW_CTRL4             0x13
#define TS_INS_GRAM_HOR_AD           0x20
#define TS_INS_GRAM_VER_AD           0x21
#define TS_INS_RW_GRAM               0x22
#define TS_INS_POW_CTRL7             0x29
#define TS_INS_FRM_RATE_COL_CTRL     0x2B
#define TS_INS_GAMMA_CTRL1           0x30
#define TS_INS_GAMMA_CTRL2           0x31
#define TS_INS_GAMMA_CTRL3           0x32
#define TS_INS_GAMMA_CTRL4           0x35 
#define TS_INS_GAMMA_CTRL5           0x36
#define TS_INS_GAMMA_CTRL6           0x37
#define TS_INS_GAMMA_CTRL7           0x38
#define TS_INS_GAMMA_CTRL8           0x39
#define TS_INS_GAMMA_CTRL9           0x3C
#define TS_INS_GAMMA_CTRL10          0x3D
#define TS_INS_HOR_START_AD          0x50
#define TS_INS_HOR_END_AD            0x51
#define TS_INS_VER_START_AD          0x52
#define TS_INS_VER_END_AD            0x53
#define TS_INS_GATE_SCAN_CTRL1       0x60
#define TS_INS_GATE_SCAN_CTRL2       0x61
#define TS_INS_GATE_SCAN_CTRL3       0x6A
#define TS_INS_PART_IMG1_DISP_POS    0x80
#define TS_INS_PART_IMG1_START_AD    0x81
#define TS_INS_PART_IMG1_END_AD      0x82
#define TS_INS_PART_IMG2_DISP_POS    0x83
#define TS_INS_PART_IMG2_START_AD    0x84
#define TS_INS_PART_IMG2_END_AD      0x85
#define TS_INS_PANEL_IF_CTRL1        0x90
#define TS_INS_PANEL_IF_CTRL2        0x92
#define TS_INS_PANEL_IF_CTRL3        0x93
#define TS_INS_PANEL_IF_CTRL4        0x95
#define TS_INS_PANEL_IF_CTRL5        0x97
#define TS_INS_PANEL_IF_CTRL6        0x98           


#ifdef LANDSCAPE
#define TS_SIZE_X					320
#define TS_SIZE_Y					240
#define TS_VAL_ENTRY_MOD			0x0028
#define TS_INS_GRAM_ADX				TS_INS_GRAM_VER_AD
#define TS_INS_GRAM_ADY				TS_INS_GRAM_HOR_AD
#define TS_INS_START_ADX   			TS_INS_VER_START_AD
#define TS_INS_END_ADX   			TS_INS_VER_END_AD
#define TS_INS_START_ADY   			TS_INS_HOR_START_AD
#define TS_INS_END_ADY   			TS_INS_HOR_END_AD
#else
#define TS_SIZE_X                    240
#define TS_SIZE_Y                    320
#define TS_VAL_ENTRY_MOD             0x0030
#define TS_INS_GRAM_ADX              TS_INS_GRAM_HOR_AD
#define TS_INS_GRAM_ADY              TS_INS_GRAM_VER_AD
#define TS_INS_START_ADX             TS_INS_HOR_START_AD
#define TS_INS_END_ADX               TS_INS_HOR_END_AD
#define TS_INS_START_ADY             TS_INS_VER_START_AD
#define TS_INS_END_ADY               TS_INS_VER_END_AD
#endif


#define RGB2COL(red,green,blue) ((unsigned short)(((blue>>3)<<11)|((green>>2)<<5)|(red>>3)))

#define RED                  0x001F
#define GREEN                0x07E0
#define BLUE                 0xF800
#define YELLOW               0x07FF
#define PURPLE               0xF81F
#define BLACK                0x0000
#define WHITE                0xFFFF
#define GRAY                 RGB2COL(0x95,0x95,0x95)
#define LIGHT_RED            RGB2COL(0xF2,0x6C,0x4E)
#define DARK_RED             RGB2COL(0x79,0x00,0x00)
#define LIGHT_GREEN          RGB2COL(0x3B,0xB8,0x78)
#define DARK_GREEN           RGB2COL(0x00,0x58,0x25)
#define LIGHT_BLUE           RGB2COL(0x00,0xBF,0xF3)
#define DARK_BLUE            RGB2COL(0x00,0x5B,0x7F)
#define LIGHT_YELLOW         RGB2COL(0xFF,0xF4,0x68)
#define DARK_YELLOW          RGB2COL(0xAB,0xA0,0x00)
#define MAGENTA              RGB2COL(0xFF,0x00,0xFF)
#define CYAN                 RGB2COL(0x00,0xFF,0xFF)
#define BROWN                RGB2COL(0xA6,0x7C,0x51)
#define SILVER               RGB2COL(0xCC,0xCC,0xCC)
#define GOLD                 RGB2COL(0xD7,0xCD,0x19)



unsigned char x_text=0,y_text=0;

const unsigned char font8x16[97][16]= 
{
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, // space 0x20
0x00,0x00,0x18,0x3C,0x3C,0x3C,0x18,0x18,0x18,0x00,0x18,0x18,0x00,0x00,0x00,0x00, // !
0x00,0x63,0x63,0x63,0x22,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, // "
0x00,0x00,0x00,0x36,0x36,0x7F,0x36,0x36,0x36,0x7F,0x36,0x36,0x00,0x00,0x00,0x00, // #
0x0C,0x0C,0x3E,0x63,0x61,0x60,0x3E,0x03,0x03,0x43,0x63,0x3E,0x0C,0x0C,0x00,0x00, // $
0x00,0x00,0x00,0x00,0x00,0x61,0x63,0x06,0x0C,0x18,0x33,0x63,0x00,0x00,0x00,0x00, // %
0x00,0x00,0x00,0x1C,0x36,0x36,0x1C,0x3B,0x6E,0x66,0x66,0x3B,0x00,0x00,0x00,0x00, // &
0x00,0x30,0x30,0x30,0x60,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, // '
0x00,0x00,0x0C,0x18,0x18,0x30,0x30,0x30,0x30,0x18,0x18,0x0C,0x00,0x00,0x00,0x00, // (
0x00,0x00,0x18,0x0C,0x0C,0x06,0x06,0x06,0x06,0x0C,0x0C,0x18,0x00,0x00,0x00,0x00, // )
0x00,0x00,0x00,0x00,0x42,0x66,0x3C,0xFF,0x3C,0x66,0x42,0x00,0x00,0x00,0x00,0x00, // *
0x00,0x00,0x00,0x00,0x18,0x18,0x18,0xFF,0x18,0x18,0x18,0x00,0x00,0x00,0x00,0x00, // +
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x18,0x18,0x30,0x00,0x00, // ,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, // -
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x18,0x18,0x00,0x00,0x00,0x00, // .
0x00,0x00,0x01,0x03,0x07,0x0E,0x1C,0x38,0x70,0xE0,0xC0,0x80,0x00,0x00,0x00,0x00, // / (forward slash)
0x00,0x00,0x3E,0x63,0x63,0x63,0x6B,0x6B,0x63,0x63,0x63,0x3E,0x00,0x00,0x00,0x00, // 0 0x30
0x00,0x00,0x0C,0x1C,0x3C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x3F,0x00,0x00,0x00,0x00, // 1
0x00,0x00,0x3E,0x63,0x03,0x06,0x0C,0x18,0x30,0x61,0x63,0x7F,0x00,0x00,0x00,0x00, // 2
0x00,0x00,0x3E,0x63,0x03,0x03,0x1E,0x03,0x03,0x03,0x63,0x3E,0x00,0x00,0x00,0x00, // 3
0x00,0x00,0x06,0x0E,0x1E,0x36,0x66,0x66,0x7F,0x06,0x06,0x0F,0x00,0x00,0x00,0x00, // 4
0x00,0x00,0x7F,0x60,0x60,0x60,0x7E,0x03,0x03,0x63,0x73,0x3E,0x00,0x00,0x00,0x00, // 5
0x00,0x00,0x1C,0x30,0x60,0x60,0x7E,0x63,0x63,0x63,0x63,0x3E,0x00,0x00,0x00,0x00, // 6
0x00,0x00,0x7F,0x63,0x03,0x06,0x06,0x0C,0x0C,0x18,0x18,0x18,0x00,0x00,0x00,0x00, // 7
0x00,0x00,0x3E,0x63,0x63,0x63,0x3E,0x63,0x63,0x63,0x63,0x3E,0x00,0x00,0x00,0x00, // 8
0x00,0x00,0x3E,0x63,0x63,0x63,0x63,0x3F,0x03,0x03,0x06,0x3C,0x00,0x00,0x00,0x00, // 9
0x00,0x00,0x00,0x00,0x00,0x18,0x18,0x00,0x00,0x00,0x18,0x18,0x00,0x00,0x00,0x00, // :
0x00,0x00,0x00,0x00,0x00,0x18,0x18,0x00,0x00,0x00,0x18,0x18,0x18,0x30,0x00,0x00, // ;
0x00,0x00,0x00,0x06,0x0C,0x18,0x30,0x60,0x30,0x18,0x0C,0x06,0x00,0x00,0x00,0x00, // <
0x00,0x00,0x00,0x00,0x00,0x00,0x7E,0x00,0x00,0x7E,0x00,0x00,0x00,0x00,0x00,0x00, // =
0x00,0x00,0x00,0x60,0x30,0x18,0x0C,0x06,0x0C,0x18,0x30,0x60,0x00,0x00,0x00,0x00, // >
0x00,0x00,0x3E,0x63,0x63,0x06,0x0C,0x0C,0x0C,0x00,0x0C,0x0C,0x00,0x00,0x00,0x00, // ?
0x00,0x00,0x3E,0x63,0x63,0x6F,0x6B,0x6B,0x6E,0x60,0x60,0x3E,0x00,0x00,0x00,0x00, // @ 0x40
0x00,0x00,0x08,0x1C,0x36,0x63,0x63,0x63,0x7F,0x63,0x63,0x63,0x00,0x00,0x00,0x00, // A
0x00,0x00,0x7E,0x33,0x33,0x33,0x3E,0x33,0x33,0x33,0x33,0x7E,0x00,0x00,0x00,0x00, // B
0x00,0x00,0x1E,0x33,0x61,0x60,0x60,0x60,0x60,0x61,0x33,0x1E,0x00,0x00,0x00,0x00, // C
0x00,0x00,0x7C,0x36,0x33,0x33,0x33,0x33,0x33,0x33,0x36,0x7C,0x00,0x00,0x00,0x00, // D
0x00,0x00,0x7F,0x33,0x31,0x34,0x3C,0x34,0x30,0x31,0x33,0x7F,0x00,0x00,0x00,0x00, // E
0x00,0x00,0x7F,0x33,0x31,0x34,0x3C,0x34,0x30,0x30,0x30,0x78,0x00,0x00,0x00,0x00, // F
0x00,0x00,0x1E,0x33,0x61,0x60,0x60,0x6F,0x63,0x63,0x37,0x1D,0x00,0x00,0x00,0x00, // G
0x00,0x00,0x63,0x63,0x63,0x63,0x7F,0x63,0x63,0x63,0x63,0x63,0x00,0x00,0x00,0x00, // H
0x00,0x00,0x3C,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x18,0x3C,0x00,0x00,0x00,0x00, // I
0x00,0x00,0x0F,0x06,0x06,0x06,0x06,0x06,0x06,0x66,0x66,0x3C,0x00,0x00,0x00,0x00, // J
0x00,0x00,0x73,0x33,0x36,0x36,0x3C,0x36,0x36,0x33,0x33,0x73,0x00,0x00,0x00,0x00, // K
0x00,0x00,0x78,0x30,0x30,0x30,0x30,0x30,0x30,0x31,0x33,0x7F,0x00,0x00,0x00,0x00, // L
0x00,0x00,0x63,0x77,0x7F,0x6B,0x63,0x63,0x63,0x63,0x63,0x63,0x00,0x00,0x00,0x00, // M
0x00,0x00,0x63,0x63,0x73,0x7B,0x7F,0x6F,0x67,0x63,0x63,0x63,0x00,0x00,0x00,0x00, // N
0x00,0x00,0x1C,0x36,0x63,0x63,0x63,0x63,0x63,0x63,0x36,0x1C,0x00,0x00,0x00,0x00, // O
0x00,0x00,0x7E,0x33,0x33,0x33,0x3E,0x30,0x30,0x30,0x30,0x78,0x00,0x00,0x00,0x00, // P 0x50
0x00,0x00,0x3E,0x63,0x63,0x63,0x63,0x63,0x63,0x6B,0x6F,0x3E,0x06,0x07,0x00,0x00, // Q
0x00,0x00,0x7E,0x33,0x33,0x33,0x3E,0x36,0x36,0x33,0x33,0x73,0x00,0x00,0x00,0x00, // R
0x00,0x00,0x3E,0x63,0x63,0x30,0x1C,0x06,0x03,0x63,0x63,0x3E,0x00,0x00,0x00,0x00, // S
0x00,0x00,0xFF,0xDB,0x99,0x18,0x18,0x18,0x18,0x18,0x18,0x3C,0x00,0x00,0x00,0x00, // T
0x00,0x00,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x3E,0x00,0x00,0x00,0x00, // U
0x00,0x00,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x36,0x1C,0x08,0x00,0x00,0x00,0x00, // V
0x00,0x00,0x63,0x63,0x63,0x63,0x63,0x6B,0x6B,0x7F,0x36,0x36,0x00,0x00,0x00,0x00, // W
0x00,0x00,0xC3,0xC3,0x66,0x3C,0x18,0x18,0x3C,0x66,0xC3,0xC3,0x00,0x00,0x00,0x00, // X
0x00,0x00,0xC3,0xC3,0xC3,0x66,0x3C,0x18,0x18,0x18,0x18,0x3C,0x00,0x00,0x00,0x00, // Y
0x00,0x00,0x7F,0x63,0x43,0x06,0x0C,0x18,0x30,0x61,0x63,0x7F,0x00,0x00,0x00,0x00, // Z
0x00,0x00,0x3C,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x30,0x3C,0x00,0x00,0x00,0x00, // [
0x00,0x00,0x80,0xC0,0xE0,0x70,0x38,0x1C,0x0E,0x07,0x03,0x01,0x00,0x00,0x00,0x00, // \ (back slash)
0x00,0x00,0x3C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x3C,0x00,0x00,0x00,0x00, // ]
0x08,0x1C,0x36,0x63,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, // ^
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0x00,0x00,0x00, // _
0x18,0x18,0x0C,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, // ` 0x60
0x00,0x00,0x00,0x00,0x00,0x3C,0x46,0x06,0x3E,0x66,0x66,0x3B,0x00,0x00,0x00,0x00, // a
0x00,0x00,0x70,0x30,0x30,0x3C,0x36,0x33,0x33,0x33,0x33,0x6E,0x00,0x00,0x00,0x00, // b
0x00,0x00,0x00,0x00,0x00,0x3E,0x63,0x60,0x60,0x60,0x63,0x3E,0x00,0x00,0x00,0x00, // c
0x00,0x00,0x0E,0x06,0x06,0x1E,0x36,0x66,0x66,0x66,0x66,0x3B,0x00,0x00,0x00,0x00, // d
0x00,0x00,0x00,0x00,0x00,0x3E,0x63,0x63,0x7E,0x60,0x63,0x3E,0x00,0x00,0x00,0x00, // e
0x00,0x00,0x1C,0x36,0x32,0x30,0x7C,0x30,0x30,0x30,0x30,0x78,0x00,0x00,0x00,0x00, // f
0x00,0x00,0x00,0x00,0x00,0x3B,0x66,0x66,0x66,0x66,0x3E,0x06,0x66,0x3C,0x00,0x00, // g
0x00,0x00,0x70,0x30,0x30,0x36,0x3B,0x33,0x33,0x33,0x33,0x73,0x00,0x00,0x00,0x00, // h
0x00,0x00,0x0C,0x0C,0x00,0x1C,0x0C,0x0C,0x0C,0x0C,0x0C,0x1E,0x00,0x00,0x00,0x00, // i
0x00,0x00,0x06,0x06,0x00,0x0E,0x06,0x06,0x06,0x06,0x06,0x66,0x66,0x3C,0x00,0x00, // j
0x00,0x00,0x70,0x30,0x30,0x33,0x33,0x36,0x3C,0x36,0x33,0x73,0x00,0x00,0x00,0x00, // k
0x00,0x00,0x1C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x0C,0x1E,0x00,0x00,0x00,0x00, // l
0x00,0x00,0x00,0x00,0x00,0x6E,0x7F,0x6B,0x6B,0x6B,0x6B,0x6B,0x00,0x00,0x00,0x00, // m
0x00,0x00,0x00,0x00,0x00,0x6E,0x33,0x33,0x33,0x33,0x33,0x33,0x00,0x00,0x00,0x00, // n
0x00,0x00,0x00,0x00,0x00,0x3E,0x63,0x63,0x63,0x63,0x63,0x3E,0x00,0x00,0x00,0x00, // o
0x00,0x00,0x00,0x00,0x00,0x6E,0x33,0x33,0x33,0x33,0x3E,0x30,0x30,0x78,0x00,0x00, // p 0x70
0x00,0x00,0x00,0x00,0x00,0x3B,0x66,0x66,0x66,0x66,0x3E,0x06,0x06,0x0F,0x00,0x00, // q
0x00,0x00,0x00,0x00,0x00,0x6E,0x3B,0x33,0x30,0x30,0x30,0x78,0x00,0x00,0x00,0x00, // r
0x00,0x00,0x00,0x00,0x00,0x3E,0x63,0x38,0x0E,0x03,0x63,0x3E,0x00,0x00,0x00,0x00, // s
0x00,0x00,0x08,0x18,0x18,0x7E,0x18,0x18,0x18,0x18,0x1B,0x0E,0x00,0x00,0x00,0x00, // t
0x00,0x00,0x00,0x00,0x00,0x66,0x66,0x66,0x66,0x66,0x66,0x3B,0x00,0x00,0x00,0x00, // u
0x00,0x00,0x00,0x00,0x00,0x63,0x63,0x36,0x36,0x1C,0x1C,0x08,0x00,0x00,0x00,0x00, // v
0x00,0x00,0x00,0x00,0x00,0x63,0x63,0x63,0x6B,0x6B,0x7F,0x36,0x00,0x00,0x00,0x00, // w
0x00,0x00,0x00,0x00,0x00,0x63,0x36,0x1C,0x1C,0x1C,0x36,0x63,0x00,0x00,0x00,0x00, // x
0x00,0x00,0x00,0x00,0x00,0x63,0x63,0x63,0x63,0x63,0x3F,0x03,0x06,0x3C,0x00,0x00, // y
0x00,0x00,0x00,0x00,0x00,0x7F,0x66,0x0C,0x18,0x30,0x63,0x7F,0x00,0x00,0x00,0x00, // z
0x00,0x00,0x0E,0x18,0x18,0x18,0x70,0x18,0x18,0x18,0x18,0x0E,0x00,0x00,0x00,0x00, // {
0x00,0x00,0x18,0x18,0x18,0x18,0x18,0x00,0x18,0x18,0x18,0x18,0x18,0x00,0x00,0x00, // |
0x00,0x00,0x70,0x18,0x18,0x18,0x0E,0x18,0x18,0x18,0x18,0x70,0x00,0x00,0x00,0x00, // }
0x00,0x00,0x3B,0x6E,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, // ~
0x00,0x70,0xD8,0xD8,0x70,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00  // DEL
};  

const unsigned int font22x32[][24]={
0x001ffc00,0x01ffffc0,0x07fffff0,0x1ffffff8,0x3ffffffc,0x3ffffffe,0x7fe007fe,0x7e00007f,0xfc00003f,0xf800001f,0xf800001f,0xf800001f,0xf800001f,0xfc00003f,0x7e00007f,0x7fe007fe,0x3ffffffe,0x1ffffff8,0x07fffff0,0x01ffffc0,0x001ffc00,0,0,0,//0
0xe0000000,0xf00000e0,0xf00000f0,0xf00000f8,0xf000007c,0xf000007c,0xf000007e,0xfffffffe,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xf0000000,0xf0000000,0xf0000000,0xf0000000,0xf0000000,0xf0000000,0xf0000000,0xe0000000,0,0,0,//1
0x000000f0,0xfc0000f8,0xfe0000fc,0xff00007e,0xff80003e,0xffc0003e,0xffe0003f,0xfff0001f,0xfbf8001f,0xf9fe001f,0xf8ff003f,0xf87fc03f,0xf83ff8ff,0xf81fffff,0xf80fffff,0xf807fffe,0xf801fffe,0xf800fffc,0xf8003ff8,0xf8000fe0,0xf8000000,0,0,0,//2 
0x3e000078,0x7e00007c,0x7c00003e,0x7c03e03e,0x7803e01e,0xf803e01f,0xf803e01f,0xf803e01f,0xf803e01f,0xf803e01f,0xfc07f03f,0xfc07f87f,0x7e0fffff,0x7fffffff,0x7ffffffe,0x3fff3ffe,0x3fff1ffc,0x1ffe0ff8,0x0ffc01c0,0x03f80000,0,0,0,0,//3
0x00f00000,0x01fe0000,0x01ff0000,0x01ffc000,0x01fff000,0x01fffc00,0x01f3fe00,0x01f0ff80,0x01f03fe0,0x01f01ff8,0x01f007fc,0x01f001fe,0x01f0007f,0x01f0003f,0xffffffff,0xffffffff,0xffffffff,0xffffffff,0xfffffffe,0x01f00000,0x01f00000,0x01f00000,0x01f00000,0,//4 
0x3c000000,0x7c01fffe,0x7c01ffff,0x7c01ffff,0xf801ffff,0xf801ffff,0xf801f03f,0xf801f03f,0xf801f03f,0xf801f03f,0xfc01f03f,0x7c03f03f,0x7f07e03f,0x7fffe03f,0x3fffe03f,0x3fffc03f,0x1fffc03f,0x0fff801e,0x03ff0000,0x00780000,0,0,0,0,//5
0x00fffc00,0x07ffff80,0x1fffffe0,0x3ffffff0,0x3ffffff8,0x7ffffffc,0x7f03e1fe,0xfc01e07e,0xf801e03e,0xf801f01f,0xf800f01f,0xf800f00f,0xf801f00f,0x7c01f00f,0x7e07f00f,0x7ffff01f,0x3fffe01f,0x3fffe03f,0x1fffc03e,0x07ff8000,0x01fe0000,0,0,0,//6
0x0000003f,0x0000003f,0x0000003f,0xf000003f,0xfc00003f,0xff00003f,0xffe0003f,0xfff0003f,0x7ffe003f,0x1fff803f,0x07ffe03f,0x01fffc3f,0x007fff3f,0x001fffff,0x0007ffff,0x0000ffff,0x00003fff,0x00000fff,0x000001ff,0x0000007e,0,0,0,0,//7
0x07f80000,0x1ffc07f8,0x3ffe0ffc,0x3fff1ffe,0x7fff3ffe,0x7fffffff,0x7c1ffe7f,0xf80ff81f,0xf807f01f,0xf803e00f,0xf803e00f,0xf803e00f,0xf807f01f,0xf80ff81f,0x7c1ffe7f,0x7fffffff,0x7fff3ffe,0x3fff1ffe,0x3ffe0ffc,0x1ffc07f8,0x07f80000,0,0,0,//8
0x0000ffc0,0x7c01fff0,0x7c03fff8,0x7807fffc,0xf807fffe,0xf807fffe,0xf80fc03f,0xf80f801f,0xf80f801f,0xf80f801f,0xf80f800f,0x7c07801f,0x7e07801f,0x7f07c07f,0x3fe7e3fe,0x1ffffffe,0x0ffffffc,0x07fffffc,0x03fffff0,0x007fffc0,0x0007fc00,0,0,0,//9
0,0x0003c000,0x0003c000,0x01c3c380,0x01e3c780,0x00f3cf00,0x003ffc00,0x007ff800,0x001ff800,0x000ff000,0x07ffffe0,0x07ffffe0,0x07ffffe0,0x000ff800,0x001ffc00,0x003ffe00,0x007bdf00,0x00f3c780,0x01e3c3e0,0x01c3c1c0,0x0003c000,0x0003c000,0,0,//*
0x00780f00,0xe0780f00,0xfe780f00,0xfff80f00,0x7fff0f00,0x03ffff00,0x007fffc0,0x0079fffe,0x00780fff,0x00780fff,0x00780703,0x00780f00,0x00780f00,0xe0780f00,0xfe780f00,0xfff80f00,0x7fff8f00,0x03ffff00,0x007fffc0,0x0079fffe,0x00780fff,0x00780fff,0x00780f03,0x00780f03,//#
};

//-----------------------------------------------------------------------
	// send a word data to the lcd
//-----------------------------------------------------------------------
void lcd_write_index_register(unsigned char ins)
    {
    CS_LOW;
    RS_LOW;
    LPC_GPIO1->FIOCLR3=0xff; 
    LPC_GPIO1->FIOPIN2=ins;
    WR_LOW;
	LPC_GPIO1->FIOCLR1=0;//nop 
    WR_HIGH;
    CS_HIGH;        
    }
	
//-----------------------------------------------------------------------
	// write a word data into the WDR lcd register
//-----------------------------------------------------------------------
void lcd_write_wdr(unsigned short data)
    { 
    CS_LOW;
    RS_HIGH;
    LPC_GPIO1->FIOPINH=data; 
    WR_LOW;
	LPC_GPIO1->FIOCLR1=0;//nop
    WR_HIGH;
    CS_HIGH;           
    }
	
//-----------------------------------------------------------------------
	// read data from rdr lcd register
//-----------------------------------------------------------------------
unsigned short lcd_read_rdr(void)
    { 
    unsigned short rdr_data;  
    LCD_DATAPORT_INPUT;
    CS_LOW;
	RD_LOW;
	rdr_data=LPC_GPIO1->FIOPINH;
	RD_HIGH;
	CS_HIGH;
	LCD_DATAPORT_OUTPUT;
    return rdr_data;
    }


//-----------------------------------------------------------------------
	// clears the lcd panel
//-----------------------------------------------------------------------
void lcd_clear_screen(void)
    {  
    unsigned int counter;
    lcd_write_index_register(TS_INS_GRAM_ADX);
    lcd_write_wdr(0);
    lcd_write_index_register(TS_INS_GRAM_ADY);
    lcd_write_wdr(0);             
    lcd_write_index_register(TS_INS_START_ADX);
    lcd_write_wdr(0);
    lcd_write_index_register(TS_INS_END_ADX);
    #ifdef PORTRAIT
    lcd_write_wdr(239);
    #else
    lcd_write_wdr(319); 
    #endif
    lcd_write_index_register(TS_INS_START_ADY);
    lcd_write_wdr(0);
    lcd_write_index_register(TS_INS_END_ADY);
    #ifdef PORTRAIT
    lcd_write_wdr(319);
    #else
    lcd_write_wdr(239); 
    #endif 
    lcd_write_index_register(TS_INS_RW_GRAM);
    CS_LOW;
    RS_HIGH;
    LPC_GPIO1->FIOSETH=0xffff;     
     for(counter=0;counter<76800;counter++){
     WR_LOW;
	 LPC_GPIO1->FIOCLR1=0;//nop
     WR_HIGH;                   
     }
    CS_HIGH;
    }
//-----------------------------------------------------------------------
	// set background color
//-----------------------------------------------------------------------
void lcd_background_color(unsigned short color)
    {  
    unsigned int counter;
    lcd_write_index_register(TS_INS_GRAM_ADX);
    lcd_write_wdr(0);
    lcd_write_index_register(TS_INS_GRAM_ADY);
    lcd_write_wdr(0);             
    lcd_write_index_register(TS_INS_START_ADX);
    lcd_write_wdr(0);
    lcd_write_index_register(TS_INS_END_ADX);
    #ifdef PORTRAIT
    lcd_write_wdr(239);
    #else
    lcd_write_wdr(319); 
    #endif
    lcd_write_index_register(TS_INS_START_ADY);
    lcd_write_wdr(0);
    lcd_write_index_register(TS_INS_END_ADY);
    #ifdef PORTRAIT
    lcd_write_wdr(319);
    #else
    lcd_write_wdr(239); 
    #endif 
    lcd_write_index_register(TS_INS_RW_GRAM);
    CS_LOW;
    RS_HIGH;
    LPC_GPIO1->FIOPINH=color;     
     for(counter=0;counter<76800;counter++){
     WR_LOW;
	 LPC_GPIO1->FIOCLR1=0;//nop
     WR_HIGH;                   
     }
    CS_HIGH;
    }
	
//-----------------------------------------------------------------------	
	// lcd initialization
//-----------------------------------------------------------------------	
void lcd_init(void)
    {
	int j; 
    LPC_GPIO1->FIODIR1=0xc7;
	LPC_GPIO1->FIOPIN1=0xc7;
    LCD_DATAPORT_OUTPUT;
          
    // reset lcd chipset
    RST_LOW;
    //delay_ms(1);           
	for(j=32000;j>0;j--);
    RST_HIGH;          
    
    lcd_write_index_register(0x00E3);
    lcd_write_wdr(0x3008);                     //set the internal timing
    lcd_write_index_register(0x00E7);
    lcd_write_wdr(0x0012);                     //set the internal timing
    lcd_write_index_register(0x00EF);
    lcd_write_wdr(0x1231);                     //set the internal timing
    lcd_write_index_register(TS_INS_START_OSC);
    lcd_write_wdr(0x0001);                     //start oscillator
    //if(lcd_read_rdr()==0x9325) {DDRB.7=1;PORTB.7=1;}
    //delay_ms(50);
	for(j=1600000;j>0;j--);
    lcd_write_index_register(TS_INS_DRIV_OUT_CTRL);
    lcd_write_wdr(0x0100);                     //set SS, SM
    lcd_write_index_register(TS_INS_DRIV_WAV_CTRL);
    lcd_write_wdr(0x0700);                     //set 1 line inversion
    
    lcd_write_index_register(TS_INS_ENTRY_MOD);
    lcd_write_wdr(TS_VAL_ENTRY_MOD);            //set GRAM write direction, BGR=0

    lcd_write_index_register(TS_INS_RESIZE_CTRL);
    lcd_write_wdr(0x0000);                     //no resizing

    lcd_write_index_register(TS_INS_DISP_CTRL2);
    lcd_write_wdr(0x0202);                     //front & back porch periods = 2
    lcd_write_index_register(TS_INS_DISP_CTRL3);
    lcd_write_wdr(0x0000);                     
    lcd_write_index_register(TS_INS_DISP_CTRL4);
    lcd_write_wdr(0x0000);                     
    lcd_write_index_register(TS_INS_RGB_DISP_IF_CTRL1);
    lcd_write_wdr(0x0000);                     //select system interface                
    lcd_write_index_register(TS_INS_FRM_MARKER_POS);
    lcd_write_wdr(0x0000);                     
    lcd_write_index_register(TS_INS_RGB_DISP_IF_CTRL2);
    lcd_write_wdr(0x0000);                    
    
    lcd_write_index_register(TS_INS_POW_CTRL1);
    lcd_write_wdr(0x0000);
    lcd_write_index_register(TS_INS_POW_CTRL2);
    lcd_write_wdr(0x0007);                     
    lcd_write_index_register(TS_INS_POW_CTRL3);
    lcd_write_wdr(0x0000);
    lcd_write_index_register(TS_INS_POW_CTRL4);
    lcd_write_wdr(0x0000);                     
    //delay_ms(200);
	for(j=6400000;j>0;j--);
    lcd_write_index_register(TS_INS_POW_CTRL1);
    lcd_write_wdr(0x1690);
    lcd_write_index_register(TS_INS_POW_CTRL2);
    lcd_write_wdr(0x0007); //lcd_write_wdr(0x0137);                     
    //delay_ms(50);
	for(j=1600000;j>0;j--);

    lcd_write_index_register(TS_INS_POW_CTRL3);
    lcd_write_wdr(0x001A); //lcd_write_wdr(0x013C);
    //delay_ms(50);
	for(j=1600000;j>0;j--);

    lcd_write_index_register(TS_INS_POW_CTRL4);
    lcd_write_wdr(0x1800); //lcd_write_wdr(0x1400);
    lcd_write_index_register(TS_INS_POW_CTRL7);
    lcd_write_wdr(0x002A); //lcd_write_wdr(0x0007);
    //delay_ms(50);
	for(j=1600000;j>0;j--);

    lcd_write_index_register(TS_INS_GRAM_HOR_AD);
    lcd_write_wdr(0x0000);
    lcd_write_index_register(TS_INS_GRAM_VER_AD);
    lcd_write_wdr(0x0000);

    lcd_write_index_register(TS_INS_GAMMA_CTRL1);
    lcd_write_wdr(0x0000);
    lcd_write_index_register(TS_INS_GAMMA_CTRL2);
    lcd_write_wdr(0x0000);
    lcd_write_index_register(TS_INS_GAMMA_CTRL3);
    lcd_write_wdr(0x0000);
    lcd_write_index_register(TS_INS_GAMMA_CTRL4);
    lcd_write_wdr(0x0000);
    lcd_write_index_register(TS_INS_GAMMA_CTRL5);
    lcd_write_wdr(0x0000);
    lcd_write_index_register(TS_INS_GAMMA_CTRL6);
    lcd_write_wdr(0x0406);
    lcd_write_index_register(TS_INS_GAMMA_CTRL7);
    lcd_write_wdr(0x0006);
    lcd_write_index_register(TS_INS_GAMMA_CTRL8);
    lcd_write_wdr(0x0404);
    lcd_write_index_register(TS_INS_GAMMA_CTRL9);
    lcd_write_wdr(0x0700);
    lcd_write_index_register(TS_INS_GAMMA_CTRL10);
    lcd_write_wdr(0x0A08);

    lcd_write_index_register(TS_INS_HOR_START_AD);
    lcd_write_wdr(0x0000);
    lcd_write_index_register(TS_INS_HOR_END_AD);
    lcd_write_wdr(0x00EF);
    lcd_write_index_register(TS_INS_VER_START_AD);
    lcd_write_wdr(0x0000);
    lcd_write_index_register(TS_INS_VER_END_AD);
    lcd_write_wdr(0x013F);
    lcd_write_index_register(TS_INS_GATE_SCAN_CTRL1);
    lcd_write_wdr(0xA700);
    lcd_write_index_register(TS_INS_GATE_SCAN_CTRL2);
    lcd_write_wdr(0x0001);
    lcd_write_index_register(TS_INS_GATE_SCAN_CTRL3);
    lcd_write_wdr(0x0000);

    lcd_write_index_register(TS_INS_PART_IMG1_DISP_POS);
    lcd_write_wdr(0x0000);
    lcd_write_index_register(TS_INS_PART_IMG1_START_AD);
    lcd_write_wdr(0x0000);
    lcd_write_index_register(TS_INS_PART_IMG1_END_AD);
    lcd_write_wdr(0x0000);
    lcd_write_index_register(TS_INS_PART_IMG2_DISP_POS);
    lcd_write_wdr(0x0000);
    lcd_write_index_register(TS_INS_PART_IMG2_START_AD);
    lcd_write_wdr(0x0000);
    lcd_write_index_register(TS_INS_PART_IMG2_END_AD);
    lcd_write_wdr(0x0000);

    lcd_write_index_register(TS_INS_PANEL_IF_CTRL1);
    lcd_write_wdr(0x0010);
    lcd_write_index_register(TS_INS_PANEL_IF_CTRL2);
    lcd_write_wdr(0x0000);
    lcd_write_index_register(TS_INS_PANEL_IF_CTRL3);
    lcd_write_wdr(0x0003);
    lcd_write_index_register(TS_INS_PANEL_IF_CTRL4);
    lcd_write_wdr(0x0110);
    lcd_write_index_register(TS_INS_PANEL_IF_CTRL5);
    lcd_write_wdr(0x0000);
    lcd_write_index_register(TS_INS_PANEL_IF_CTRL6);
    lcd_write_wdr(0x0000);

    lcd_write_index_register(TS_INS_DISP_CTRL1);
    lcd_write_wdr(0x0133);
    
    lcd_write_index_register(TS_INS_FRM_RATE_COL_CTRL);
    lcd_write_wdr(0x000D);
    
    lcd_clear_screen();
    }
	
//-----------------------------------------------------------------------
	// turn on a pixel on the lcd screen
//-----------------------------------------------------------------------
void lcd_write_pixel(unsigned short x,unsigned short y,unsigned short color)
    { 
    #ifdef LANDSCAPE
    y=239-y;
    #endif
    lcd_write_index_register(TS_INS_GRAM_ADX);
    lcd_write_wdr(x); 
    lcd_write_index_register(TS_INS_GRAM_ADY);
    lcd_write_wdr(y);
    lcd_write_index_register(TS_INS_RW_GRAM);
    lcd_write_wdr(color);
    }
//-----------------------------------------------------------------------
	// Read A Pixel Color On The LCD Screen
//-----------------------------------------------------------------------
unsigned short lcd_read_pixel(unsigned short x,unsigned short y)
    { 
	unsigned short pixel;
    #ifdef LANDSCAPE
    y=239-y;
    #endif
    lcd_write_index_register(TS_INS_GRAM_ADX);
    lcd_write_wdr(x); 
    lcd_write_index_register(TS_INS_GRAM_ADY);
    lcd_write_wdr(y);
    lcd_write_index_register(TS_INS_START_ADX);
    lcd_write_wdr(x);
    lcd_write_index_register(TS_INS_END_ADX);
    lcd_write_wdr(x); 
    lcd_write_index_register(TS_INS_START_ADY);
    lcd_write_wdr(y);
    lcd_write_index_register(TS_INS_END_ADY);
    lcd_write_wdr(y); 
    lcd_write_index_register(TS_INS_RW_GRAM);
    pixel=lcd_read_rdr();
    return pixel;
    }

//-----------------------------------------------------------------------
	// draw a line with x0,y0 and x1,y1 coordinates
//-----------------------------------------------------------------------	
void lcd_draw_line(unsigned short x0,unsigned short y0,unsigned short x1,unsigned short y1,unsigned short color) 
    {
    signed short dy=y1-y0;
    signed short dx=x1-x0;
    signed short stepx,stepy;
    if(dy<0) {dy=-dy;stepy=-1;} else {stepy=1;}
    if(dx<0) {dx=-dx;stepx=-1;} else {stepx=1;}
    dy<<=1; 
    dx<<=1; 
    lcd_write_pixel(x0,y0,color);
    if(dx>dy) 
      {
      int fraction=dy-(dx>>1); 
      while(x0!=x1) 
        {
        if(fraction>=0) 
          {
          y0+=stepy;
          fraction-=dx; 
          }
        x0+=stepx;
        fraction+=dy; 
        lcd_write_pixel(x0,y0,color);
        }
      } 
    else 
      {
      int fraction=dx-(dy>>1);
      while (y0 != y1) 
        {
        if(fraction>=0) 
          {
          x0+=stepx;
          fraction-=dy;
          }
        y0+=stepy;
        fraction+=dx;
        lcd_write_pixel(x0,y0,color);
        }
      }
    }
//-----------------------------------------------------------------------
	// draw a fill(1) or no fill(0) rectangular with specified color    
//-----------------------------------------------------------------------	
void lcd_draw_rectangle(unsigned short x0,unsigned short y0,unsigned short x1,unsigned short y1,unsigned char fill,unsigned short color)
    { 
    if(fill)
      {
      unsigned short counter_x; 
      unsigned char  counter_y; 
      
      lcd_write_index_register(TS_INS_GRAM_ADX);
      lcd_write_wdr(x0);
      lcd_write_index_register(TS_INS_GRAM_ADY);
      lcd_write_wdr(y0);  
      lcd_write_index_register(TS_INS_START_ADX);
      lcd_write_wdr(x0);
      lcd_write_index_register(TS_INS_END_ADX);
      lcd_write_wdr(x1);
      #ifdef PORTRAIT
      lcd_write_index_register(TS_INS_START_ADY);
      lcd_write_wdr(y0);
      lcd_write_index_register(TS_INS_END_ADY);
      lcd_write_wdr(y1); 
      #else
      lcd_write_index_register(TS_INS_START_ADY);
      lcd_write_wdr(239-y1);
      lcd_write_index_register(TS_INS_END_ADY);
      lcd_write_wdr(239-y0);
      #endif  
      lcd_write_index_register(TS_INS_RW_GRAM);
      for(counter_y=y0;counter_y<=y1;counter_y++)
        {
        for(counter_x=x0;counter_x<=x1;counter_x++)
          lcd_write_wdr(color);
        }  
      } 
    else
      {
      lcd_draw_line(x0,y0,x1,y0,color);
      lcd_draw_line(x1,y0,x1,y1,color);
      lcd_draw_line(x1,y1,x0,y1,color); 
      lcd_draw_line(x0,y1,x0,y0,color);
      }
    }
//-----------------------------------------------------------------------
	// draw a fill(1) or no fill(0) circle with specified color 
//-----------------------------------------------------------------------	
void lcd_draw_circle(unsigned short x0,unsigned short y0,unsigned short radius,unsigned char fill,unsigned short color) 
    { 
    signed short x_offset,y_offset,error; 
    x_offset=0; 
    y_offset=radius; 
    error=1-radius; 

    do 
      { 
      if(fill) 
        { 
        lcd_draw_line(x0-x_offset,y0+y_offset,x0+x_offset,y0+y_offset,color); 
        lcd_draw_line(x0-x_offset,y0-y_offset,x0+x_offset,y0-y_offset,color); 
        lcd_draw_line(x0-y_offset,y0+x_offset,x0+y_offset,y0+x_offset,color); 
        lcd_draw_line(x0-y_offset,y0-x_offset,x0+y_offset,y0-x_offset,color); 
        } 
      else 
        { 
        lcd_write_pixel(x_offset+x0,y_offset+y0,color); 
        lcd_write_pixel(y_offset+x0,x_offset+y0,color); 
        lcd_write_pixel(x0-x_offset,y_offset+y0,color); 
        lcd_write_pixel(x0-y_offset,x_offset+y0,color); 
        lcd_write_pixel(y_offset+x0,y0-x_offset,color); 
        lcd_write_pixel(x_offset+x0,y0-y_offset,color); 
        lcd_write_pixel(x0-x_offset,y0-y_offset,color); 
        lcd_write_pixel(x0-y_offset,y0-x_offset,color); 
        } 

      if(error<0) 
        error+=(3+(2*(x_offset++))); 
      else 
        error+=(5+(2*((x_offset++)-(y_offset--)))); 
      }while(x_offset<=y_offset); 
    } 

//-----------------------------------------------------------------------
	// Show A Picture On The LCD Screen
//-----------------------------------------------------------------------
void lcd_write_pic(unsigned short x,unsigned short y,const unsigned short *pointer)
     {
     unsigned int counter,compare_value=(unsigned int)pointer[0]*pointer[1];
     lcd_write_index_register(TS_INS_GRAM_ADX);
     lcd_write_wdr(x); 
     lcd_write_index_register(TS_INS_START_ADX);
     lcd_write_wdr(x);
     lcd_write_index_register(TS_INS_END_ADX);
     lcd_write_wdr(x+pointer[0]-1);   
     #ifdef PORTRAIT
     lcd_write_index_register(TS_INS_GRAM_ADY);
     lcd_write_wdr(y);
     lcd_write_index_register(TS_INS_START_ADY);
     lcd_write_wdr(y);
     lcd_write_index_register(TS_INS_END_ADY);
     lcd_write_wdr(y+pointer[1]-1);
     #else     
     lcd_write_index_register(TS_INS_GRAM_ADY);
     lcd_write_wdr(239-y);
     lcd_write_index_register(TS_INS_START_ADY);
     lcd_write_wdr(239-(y+pointer[1]));
     lcd_write_index_register(TS_INS_END_ADY);
     lcd_write_wdr(239-y);
     #endif 
     lcd_write_index_register(TS_INS_RW_GRAM);
	 
	 CS_LOW;
	 RS_HIGH;  
       for(counter=0,pointer+=2;counter<compare_value;counter++,pointer++){
       LPC_GPIO1->FIOPINH=*pointer; 
       WR_LOW;
	   LPC_GPIO1->FIOCLR1=0;//nop
       WR_HIGH;
	   }
	 CS_HIGH; 
     }

//-----------------------------------------------------------------------
	// Geting darker the display
//-----------------------------------------------------------------------
/*void lcd_get_dark(void)
     {
	 unsigned short buffer[1600];//40x40 Pixel
     unsigned int counter;
	 unsigned short i,j,buf;
	 unsigned char r,g,b;
	 for(i=0;i<240;i+=40){
	  for(j=0;j<320;j+=40){
	  lcd_write_index_register(TS_INS_GRAM_ADX);
      lcd_write_wdr(i); 
      lcd_write_index_register(TS_INS_START_ADX);
      lcd_write_wdr(i);
      lcd_write_index_register(TS_INS_END_ADX);
      lcd_write_wdr(i+39);   
      lcd_write_index_register(TS_INS_GRAM_ADY);
      lcd_write_wdr(j);
      lcd_write_index_register(TS_INS_START_ADY);
      lcd_write_wdr(j);
      lcd_write_index_register(TS_INS_END_ADY);
      lcd_write_wdr(j+39);
	  lcd_write_index_register(TS_INS_RW_GRAM);
	  for(counter=0;counter<1600;counter++)buffer[counter]=lcd_read_rdr();
	  for(counter=0;counter<1600;counter++){buf=buffer[counter];b=(buf&0x1f)>>1;g=(buf&0x7e0)>>6;r=(buf&0xf800)>>12;buffer[counter]=RGB2COL(r,g,b);}
	  for(counter=0;counter<1600;counter++)lcd_write_wdr(buffer[counter]);
	  }
	 }
	}

 */
//-----------------------------------------------------------------------
    // Show A Picture by resolution x4 On The LCD Screen
//-----------------------------------------------------------------------
void lcd_write_pic_x2(unsigned int x,unsigned int y,const unsigned short *pointer)
     {
     unsigned int counter1,counter2,w=pointer[0],l=pointer[1];
     lcd_write_index_register(TS_INS_GRAM_ADX);
     lcd_write_wdr(x); 
     lcd_write_index_register(TS_INS_START_ADX);
     lcd_write_wdr(x);
     lcd_write_index_register(TS_INS_END_ADX);
     lcd_write_wdr(x+(pointer[0]*2)-1);   
     #ifdef PORTRAIT
     lcd_write_index_register(TS_INS_GRAM_ADY);
     lcd_write_wdr(y);
     lcd_write_index_register(TS_INS_START_ADY);
     lcd_write_wdr(y);
     lcd_write_index_register(TS_INS_END_ADY);
     lcd_write_wdr(y+(pointer[1]*2)-1);
     #else     
     lcd_write_index_register(TS_INS_GRAM_ADY);
     lcd_write_wdr(239-y);
     lcd_write_index_register(TS_INS_START_ADY);
     lcd_write_wdr(239-(y+(pointer[1]*2)));
     lcd_write_index_register(TS_INS_END_ADY);
     lcd_write_wdr(239-y);
     #endif 
     lcd_write_index_register(TS_INS_RW_GRAM);  
      for(counter1=0,pointer+=2;counter1<l;counter1++){
       for(counter2=0;counter2<w;counter2++,pointer++){
       lcd_write_wdr(*pointer);
       lcd_write_wdr(*pointer);
       }
       pointer-=w;
       for(counter2=0;counter2<w;counter2++,pointer++){
       lcd_write_wdr(*pointer);
       lcd_write_wdr(*pointer);
       }
      }
     }

//-----------------------------------------------------------------------	 
	// This Functions Goes The Cursor To X And Y Positions
//-----------------------------------------------------------------------	 
void lcd_gotoxy(unsigned char x,unsigned char y)
    {
	#ifdef LANDSCAPE
    if(x>=40 || y>=15) 
        {
        y+=x/40;
        x%=40;
        }
	#else
	if(x>=30 || y>=20) 
        {
        y+=x/30;
        x%=30;
        }
	#endif
    x_text=x;
    y_text=y;
    }
	
//-----------------------------------------------------------------------	
	// Puts A Character On The LCD Screen
//-----------------------------------------------------------------------	
void lcd_putchar(unsigned char character,unsigned short forground_color,unsigned char background_color_activation,unsigned short background_color)
    {  
    unsigned char width_counter,length_counter;
    unsigned char character_segment_data;
    for(length_counter=0;length_counter<16;length_counter++)
        {
        character_segment_data=font8x16[character-0x20][length_counter];
        for(width_counter=0;width_counter<8;width_counter++)
            {
            if(character_segment_data&(0x80>>width_counter)) 
              lcd_write_pixel(((short)x_text*8)+width_counter,((short)y_text*16)+length_counter,forground_color);
            else 
              {
              if(!background_color_activation)
              lcd_write_pixel(((short)x_text*8)+width_counter,((short)y_text*16)+length_counter,background_color);
              }            
            }
        }
    #ifdef LANDSCAPE
    if(++x_text>=40)
        {            
        x_text=0;
        if(++y_text>=15) y_text=0;
        }
	#else
	if(++x_text>=30)
        {            
        x_text=0;
        if(++y_text>=20) y_text=0;
        }
	#endif
    } 

//-----------------------------------------------------------------------	
	// Show A String That Stored In The Flash Memory Of The Microcontroller  
//-----------------------------------------------------------------------	
void lcd_putsf(const unsigned char *string,unsigned short forground_color,unsigned char background_color_activation,unsigned short background_color)
    {
    while(*string)
      lcd_putchar(*string++,forground_color,background_color_activation,background_color);
    }
//-----------------------------------------------------------------------	
	// Show A String That Stored In The SRAM Of The Microcontroller    
//-----------------------------------------------------------------------	
void lcd_puts(unsigned char *string,unsigned short forground_color,unsigned char background_color_activation,unsigned short background_color)
    {
    while(*string)
      lcd_putchar(*string++,forground_color,background_color_activation,background_color);
    }

//-----------------------------------------------------------------------	
	// Show A number character with large font size     
//-----------------------------------------------------------------------	
 void lcd_putnum32(char character,unsigned short x,unsigned short y,unsigned short forground_color,unsigned char background_color_activation,unsigned short background_color)
    {  
    unsigned char width_counter,length_counter;
    unsigned int character_segment_data;
    for(width_counter=0;width_counter<24;width_counter++)
        {
        character_segment_data=font22x32[character-48][width_counter];
        for(length_counter=0;length_counter<32;length_counter++)
            {
            if(character_segment_data&(0x800000001<<length_counter)) 
              lcd_write_pixel(x+width_counter,y+length_counter,forground_color);
            else 
              {
              if(!background_color_activation)
              lcd_write_pixel(x+width_counter,y+length_counter,background_color);
              }            
            }
        }
    } 
    
//-----------------------------------------------------------------------	
	// fill character with white color from x,y position to counter    
//-----------------------------------------------------------------------	
    void lcd_clear_text(unsigned char x,unsigned char y,int counter)
    {
    lcd_gotoxy(x,y);
    while(counter--)lcd_putchar(' ',WHITE,0,WHITE); 
    }
